Last Comment Bug 605357 - Scrolling with touchpad (ALPS drivers) won't work
: Scrolling with touchpad (ALPS drivers) won't work
Status: NEW
[widgetremoval][gs]
: regression
Product: Core
Classification: Components
Component: Widget: Win32 (show other bugs)
: Trunk
: x86 Windows 7
: -- normal with 23 votes (vote)
: ---
Assigned To: Cameron McCormack (:heycam)
:
Mentors:
http://getsatisfaction.com/mozilla_me...
: 611093 (view as bug list)
Depends on: 594977
Blocks: 202615 130078
  Show dependency treegraph
 
Reported: 2010-10-18 18:25 PDT by Gábor Stefanik
Modified: 2016-05-30 16:18 PDT (History)
46 users (show)
pppx: needinfo? (paul.pasca)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---
-


Attachments
Test of different tp4table config options (2.13 KB, text/plain)
2011-03-26 08:40 PDT, Uli Stärk
no flags Details
tp4table.dat from my synaptics driver (7.55 KB, text/plain)
2011-08-15 02:25 PDT, Michael A. Puls II
no flags Details

Description Gábor Stefanik 2010-10-18 18:25:46 PDT
+++ This bug was initially created as a clone of Bug #594977 +++


Scrolling with the touchpad on an Acer 5720G (ALPS) doesn't work since bug 130078. Back/forward and zoom are also broken (prior to bug 130078, all but horizontal scrolling worked).
ALPS driver version is 7.5.2015.1105 (APoint.exe is 7.3.0.29).

Reproducible: Always

Steps to Reproduce:
1. Scroll by moving a finger up and down on the right side of the touchpad.
Actual Results:  
Window contents do not scroll.

Expected Results:  
Window contents should scroll
Comment 1 Kyle Huey [:khuey] (khuey@mozilla.com) 2010-10-19 07:59:15 PDT
Setting blocking2.0 back to ? so that this can get triaged on its own and not inherit the value from the cloned bug.
Comment 2 Gábor Stefanik 2010-10-19 12:25:24 PDT
Note: Vertical scrolling can be made to work by setting HKLM\Software\Alps\Apoint\ScrMethod to 1 (some drivers set this to 1 by default, set it to 0 to reproduce this bug). However, ScrMethod=1 is much choppier/more CPU-intensive than ScrMethod=0 in almost all applications tried. Horizontal scrolling is unchanged.

Back/Forward not working is due to apoint.exe checking for MozillaUIWindowClass to enable back/forward - only it is now MozillaWindowClass. Hexediting apoint.exe to check for MozillaWindowClass instead of MozillaUIWindowClass fixes the issue. I wonder if we should create a fake MozillaUIWindowClass if apoint.exe is detected in memory, akin to ui.trackpoint_hack.enabled...
Comment 3 Joe Drew (not getting mail) 2010-10-19 12:41:09 PDT
Do we have any idea how widespread ALPS is? All Acer laptops? Just this one laptop?
Comment 4 Gábor Stefanik 2010-10-19 14:52:56 PDT
AFAIK it is the second most common touchpad after Synaptics.
Comment 5 Robert O'Callahan (:roc) (Exited; email my personal email if necessary) 2010-10-19 15:18:04 PDT
(In reply to comment #2)
> Back/Forward not working is due to apoint.exe checking for MozillaUIWindowClass
> to enable back/forward - only it is now MozillaWindowClass. Hexediting
> apoint.exe to check for MozillaWindowClass instead of MozillaUIWindowClass
> fixes the issue. I wonder if we should create a fake MozillaUIWindowClass if
> apoint.exe is detected in memory, akin to ui.trackpoint_hack.enabled...

Yeah, that should work. Although we check the registry for the driver rather than checking apoint.exe running.

Great debugging job!!! I don't suppose you have Elantech hardware as well so you can do the same job there? :-)
Comment 6 Robert O'Callahan (:roc) (Exited; email my personal email if necessary) 2010-10-19 15:19:26 PDT
I wonder if, when we add an ALPS hack, we should automatically make it stop happening in the next major driver version. That might mean they fix their driver to not require the hack. Or it might mean Firefox just breaks in the next version of their driver...
Comment 7 Gábor Stefanik 2010-10-19 15:46:08 PDT
Unfortunately I have no Elantech HW, as you may have guessed.

However, it's possible to debug this issue without an actual ALPS touchpad (the scrolling part at least - and the solution to the back/forward problem seems to be setting the root window class to MozillaUIWindowClass), by directly calling the EasyWheelEx method of apoint.dll (found in the driver package for ALPS touchpads). This method takes 3 parameters: the first is direction (0: scroll down, 1: up, 2: left, 3: right), the second is the scroll method (a value of 1 corresponds to ScrMethod=0 in the registry, while a value of 2 means ScrMethod=1), and the third one is unknown (it seems to be always 3 when called by the driver).

So, compiling the following code, and dropping the resulting exe into the Vi32 (for 32-bit) / Vi64 (for x64) directory of the driver package, can be used to debug this:

#include <windows.h>
#define ALPS_SCROLLDIR_DOWN 0
#define ALPS_SCROLLDIR_UP 1
#define ALPS_SCROLLDIR_RIGHT 2
#define ALPS_SCROLLDIR_LEFT 3
#define ALPS_SCROLLMETHOD0 1
#define ALPS_SCROLLMETHOD1 2

using namespace std;

void alps_do_scroll(int a, int b)
{
   HINSTANCE hGetProcIDDLL = LoadLibrary("Apoint.dll");
   FARPROC lpfnGetProcessID = GetProcAddress(HMODULE (hGetProcIDDLL),"EasyWheelEx");

   typedef int (__stdcall *pICFUNC)(int, int, int);

   pICFUNC MyFunction;
   MyFunction = pICFUNC(lpfnGetProcessID);

   MyFunction(a, b, 3);

   FreeLibrary(hGetProcIDDLL);
}

int main()
{
    system("sleep 10"); /* 10 seconds wait time to allow switching to the Firefox window */
    alps_do_scroll(ALPS_SCROLLDIR_DOWN, ALPS_SCROLLMETHOD0); /* broken - this bug */
    alps_do_scroll(ALPS_SCROLLDIR_DOWN, ALPS_SCROLLMETHOD1); /* works */
    alps_do_scroll(ALPS_SCROLLDIR_RIGHT, ALPS_SCROLLMETHOD0); /* broken - bug 202615 */
    return 0;
}

Simply compile this code, put the result into Vi32, execute it, and switch to a Firefox window to reproduce this bug.
Comment 8 Robert O'Callahan (:roc) (Exited; email my personal email if necessary) 2010-11-08 04:18:49 PST
I landed some patches for bug 594977. It would be useful for people to try setting ui.window_class_override to MozillaUIWindowClass (and/or enabling/disabling ui.trackpoint_hack.enabled) to confirm that that fixes the problem.

Gábor, what do you think is the best way to detect the Alps driver in the registry?
Comment 9 Gábor Stefanik 2010-11-08 07:39:20 PST
You can check the presence of the Alps driver by looking for the key HKLM\Software\Alps\Apoint. The value "ProductVer" (string) tells you the version - but be careful, you need to take the second (minor) version  number modulo 100 - 7.6.0.0 would be newer than 7.105.2000.0!

BTW, the MozillaUIWindowClass hack only fixes back/forward - scrolling with method 0 is still broken.
Comment 10 Robert O'Callahan (:roc) (Exited; email my personal email if necessary) 2010-11-08 12:44:28 PST
Any idea how to fix method 0?
Comment 11 Gábor Stefanik 2010-11-08 13:44:11 PST
I don't know, as I don't currently have time to study it - but anyone can debug the issue using the code I posted (compile it, then drop it into the 32-bit installer directory of any Alps driver). I'm currently fine with method 1 - probably the same is not true of netbook users with less CPU power to spare, though... so I will probably still debug it, just not now.
Comment 12 Cameron McCormack (:heycam) 2010-12-28 17:31:26 PST
*** Bug 611093 has been marked as a duplicate of this bug. ***
Comment 13 Robert O'Callahan (:roc) (Exited; email my personal email if necessary) 2010-12-28 18:30:41 PST
Cameron, you did such a great job on the Synaptics bug, do you want to take this one too? :-)
Comment 14 Cameron McCormack (:heycam) 2011-01-02 13:50:29 PST
OK, I will take a look later this week hopefully.
Comment 15 Cameron McCormack (:heycam) 2011-01-05 21:22:55 PST
I just tried with Gábor's test program with two versions of the ALPS driver I got from the Acer site: v7.0.1101.14 (from 2007) and v7.105.2015.1105 (from 2009).  Both had the same behaviour:

  * scrolling up or down with method 0 or 1 worked
  * scrolling left or right with method 0 or 1 didn't work

Strangely, the EasyWheelEx call takes a few seconds to complete, and does the scrolling (when it does work) at the end of that delay.  I haven't tried tracing it to see what it's actually doing.

Gábor: to save me from checking the driver lists for the hundreds of different laptop models on Acer's site, can you mail me your version of the driver to see if I can reproduce it here?
Comment 16 Gábor Stefanik 2011-01-05 22:54:31 PST
7.5.2015.1105 here (weird, not 7.105, but 7.5 - that would be the same version, but from a different manufacturer)
Comment 17 Cameron McCormack (:heycam) 2011-01-06 19:45:18 PST
I found a v7.5.2015.1105 on the Gateway site (it surprised me they still exist!) and got the same results as with v7.105.2015.1105.

You mentioned above some settings in HKLM\SOFTWARE\Alps\Apoint.  My machine doesn't have this (because I haven't installed the driver), so it might be affecting my ability to reproduce the problem with your test program.  Can you export that whole key for me?
Comment 18 Gábor Stefanik 2011-01-06 21:01:54 PST
AFAIK Apoint.dll doesn't access that key at all - it only determines how Apoint.exe calls Apoint.dll.
Comment 19 Cameron McCormack (:heycam) 2011-01-06 21:16:18 PST
Hmm.  I was running Process Monitor while running the test program, and that definitely showed attempts to access that key.
Comment 20 Timothy Nikkel (:tnikkel) 2011-01-13 14:03:49 PST
Cam's been working on this.
Comment 21 Majken Connor [:Kensie] 2011-01-22 14:07:51 PST
I'm on a Vaio with an alps touchpad driver version 7.0.501.5 (wow, old!) I haven't noticed a problem but I also normally use my mouse. Please let me know if I can be of assistance!
Comment 22 Robert O'Callahan (:roc) (Exited; email my personal email if necessary) 2011-01-23 18:13:12 PST
Can you reproduce the bug?
Comment 23 Cameron McCormack (:heycam) 2011-01-23 18:18:07 PST
No. I tried with the registry keys supplied by Gabor. I also tried installing the driver on my Windows 7 partition but they did not install properly. I will try installing them on the XP machine next, and if I cannot reproduce on that I might have difficulty without the hardware.
Comment 24 Majken Connor [:Kensie] 2011-01-23 18:28:22 PST
(In reply to comment #22)
> Can you reproduce the bug?

If the STR are simply try using the scrollpad, then it's working fine. I suppose I'll try updating the drivers and see if it breaks with new ones. If there's anything specific I should try, or specific settings to flip, registry keys to look at I'd be happy to, but I might need some hand holding if it gets complicated ;)
Comment 25 Majken Connor [:Kensie] 2011-01-23 19:21:24 PST
Ok, drivers are specific to OEM, but they work. I grabbed some acer drivers - 7.5.2021.101 and it still works here.

Build identifier: Mozilla/5.0 (Windows NT 6.0; rv:2.0b10pre) Gecko/20110121 Firefox/4.0b10pre

I'm using a VAIO VGN - SZ420N Vista Business SP2

My kids have acer notebooks, though they currently have synaptics drivers (no problems there either). Is there a forum thread or some other bug that has more people describing the systems they're having this bug on? Something to give me more ideas on how to try and reproduce.
Comment 26 Cameron McCormack (:heycam) 2011-01-23 20:39:29 PST
No luck after installing the driver on the XP machine without an ALPS touchpad.

Gábor: do you know for sure that the bug is reproducable on machines without an ALPS touchpad?  If you do not, and you have another machine without one, could you try copying over your drivers files and test program to see if can be reproduced?
Comment 27 Frank 2011-01-26 05:30:38 PST
alright guys. I tried the latest official beta 10 today on my Sony Vaio having a ALPS touchpad. (see version etc: http://img37.imageshack.us/img37/6996/372260120111423.png - these are the latest available drivers for this touchpad and they work in ALL other browsers and programs flawlessly...)

result is that vertical as well as horizontal scrolling sometimes work, but most of the time don't.

if you open any site and try to scroll for the first time on that site it sometimes works, but then again I have to click anywhere on the site at first in order to be able to scroll.

and most of the time even clicking anywhere on a page doesn't help at all and you can't scroll afterwards
Comment 28 David Maire 2011-01-28 21:25:43 PST
(In reply to comment #4)
> AFAIK it is the second most common touchpad after Synaptics.

It's very common in cheap laptops, especially netbooks.
Comment 29 Tony Mechelynck [:tonymec] 2011-02-02 19:16:36 PST
Dupe of bug 593372 (or at least related closely enough to be likely to be cured by its fix)?
Comment 30 Cameron McCormack (:heycam) 2011-02-02 19:21:29 PST
It's a different driver, so likely not to be solved by bug 593372.  (I should get access to a machine with an ALPS touchpad on Monday week, btw.)
Comment 31 Mike Shaver (:shaver -- probably not reading bugmail closely) 2011-02-08 14:10:08 PST
Can't reproduce it here, and Cam is away for another week, so we can't hold the release for it.  Will relnote, and revisit in < 12 weeks for FF5.
Comment 32 Gábor Stefanik 2011-02-08 18:22:13 PST
(In reply to comment #31)
> Can't reproduce it here, and Cam is away for another week, so we can't hold the
> release for it.  Will relnote, and revisit in < 12 weeks for FF5.

Did you set ScrMethod to 0?
Comment 33 Brad Huizenga 2011-02-08 19:10:17 PST
Also have this bug with my Synaptics trackpad on Thinkpad T410. Unable to scroll with trackpad whatsoever. Driver ver 15.0.9.0. It's some HP driver.
Comment 34 Frank 2011-02-08 23:02:48 PST
(In reply to comment #31)
> Can't reproduce it here, and Cam is away for another week, so we can't hold the
> release for it.  Will relnote, and revisit in < 12 weeks for FF5.

jo guys. take it slowly. how am I (and all the folks working on laptops) supposed to use Fx then?
Comment 35 Majken Connor [:Kensie] 2011-02-08 23:11:32 PST
(In reply to comment #34)
> (In reply to comment #31)
> > Can't reproduce it here, and Cam is away for another week, so we can't hold the
> > release for it.  Will relnote, and revisit in < 12 weeks for FF5.
> 
> jo guys. take it slowly. how am I (and all the folks working on laptops)
> supposed to use Fx then?

Well considering the people trying to reproduce (including myself) are on laptops, this isn't a problem for everyone. I tried installing a different driver for my alps touchpad and I couldn't make it happen.

Clear STR or more info on which hardware/drivers this specifically happens on would help, especially with links to said drivers.  You could try a different driver to see if the problem goes away (the dell driver worked fine on my VAIO).
Comment 36 Kyle Huey [:khuey] (khuey@mozilla.com) 2011-02-09 05:11:09 PST
problems with synaptics drivers should be filed in a separate bug
Comment 37 Cameron McCormack (:heycam) 2011-02-13 14:37:39 PST
Another data point: with Apoint.exe v5.5.101.155 on a Dell Inspiron 600M (which has an ALPS touch pad), vertical scrolling works in both Firefox 3.6 and a nightly build.  (Horizontal scrolling works in neither.)
Comment 38 Gábor Stefanik 2011-02-13 16:04:32 PST
I'm pretty sure that is true for all ALPS drivers with Firefox 3.6. The problem is with 4.0 (where the main window has no child widgets at all).
Comment 39 Cameron McCormack (:heycam) 2011-02-13 16:34:10 PST
Understood.  (Just checked Firefox 3.6 to assure myself that I was getting results I was expecting.)

I just grabbed v7.0.1101.14 from the Acer site and installed it on this Dell machine.  I can confirm with this version, on this machine, that scrolling works with ScrMethod 1 but not with 0.  This is using the touchpad itself, as well as with the test program that calls directly into Apoint.dll.  (And this version works on Firefox 3.6.)
Comment 40 Frank 2011-02-15 23:23:56 PST
alright folks. from my point of view that's a problem. how am I supposed to use Fx4 (which I'm really looking forward to for a while now) properly on my laptop? 

Would it help if you got the drivers I'm using (that ain't working)?

Get 'em here: http://min.us/mvb59XT
Comment 41 Cameron McCormack (:heycam) 2011-02-16 00:55:13 PST
It turns out that reproducing the bug is more difficult than I first thought.  I can't nail down what conditions cause scrolling not to work; the few times I have been able to reproduce it haven't been when I've had the debugger open.

Tracing through Apoint!EasyWheelEx, it looks like something similar to the Synaptics hack will also coax a scroll message out of the driver, though through a different code path.  It might be that this path doesn't trip over the same problem.  I am not overly hopeful, but please try this tryserver build to see if scrolling works (this doesn't include a window class name change to fix the forward/back problem):

http://ftp.mozilla.org/pub/mozilla.org/firefox/tryserver-builds/cmccormack@mozilla.com-eca9d286d6d6/tryserver-win32/firefox-4.0b12pre.en-US.win32.zip

Other points which may be of interest:

* The 3 passed as the last argument to EasyWheelEx is the number of lines to
  scroll with each wheel notch, as returned by SystemParametersInfo
* There doesn't seem to be a way to influence the scroll method passed to
  EasyWheelEx other than by changing the ScrMethod registry entry, which is
  global and read just when Apoint.exe starts up
Comment 42 Cameron McCormack (:heycam) 2011-02-16 01:25:03 PST
(In reply to comment #40)
> alright folks. from my point of view that's a problem. how am I supposed to use
> Fx4 (which I'm really looking forward to for a while now) properly on my
> laptop? 
> 
> Would it help if you got the drivers I'm using (that ain't working)?
> 
> Get 'em here: http://min.us/mvb59XT

Thanks for that.  I can't test the actual use of the touchpad with those drivers without the installation package, which installs at least one driver .sys file.  Just running Apoint.exe without a proper installation, I cannot get scrolling working in any program.  (This driver is similar in age to the one that comes with this Dell machine, so I suspect they it have similar behaviour, but of course I cannot be sure without testing.)  Apoint.dll in this driver also has no EasyWheelEx, only an EasyWheel, so I would need to tweak the test program to test via that route.
Comment 43 Cameron McCormack (:heycam) 2011-02-16 01:29:23 PST
Another note: on one of the rare occasions the bug did reproduce, I had Spy++ open, and no WM_MOUSEWHEEL message was being sent at all (thus precluding an issue similar to the pinch-to-zoom part of bug 593372, where a window placed under the cursor by the driver prevented proper processing of the scroll message).
Comment 44 Frank 2011-02-16 02:00:11 PST
(In reply to comment #42)
> (In reply to comment #40)
> > alright folks. from my point of view that's a problem. how am I supposed to use
> > Fx4 (which I'm really looking forward to for a while now) properly on my
> > laptop? 
> > 
> > Would it help if you got the drivers I'm using (that ain't working)?
> > 
> > Get 'em here: http://min.us/mvb59XT
> 
> Thanks for that.  I can't test the actual use of the touchpad with those
> drivers without the installation package, which installs at least one driver
> .sys file.  Just running Apoint.exe without a proper installation, I cannot get
> scrolling working in any program.  (This driver is similar in age to the one
> that comes with this Dell machine, so I suspect they it have similar behaviour,
> but of course I cannot be sure without testing.)  Apoint.dll in this driver
> also has no EasyWheelEx, only an EasyWheel, so I would need to tweak the test
> program to test via that route.

Sony does not provide an installation package for the TP drivers. Only the stuff I uploaded as is. (On installing I have to go through the device manager on Windows and manually install the stuff.)
Comment 45 Frank 2011-02-16 02:17:49 PST
(In reply to comment #41)
> It turns out that reproducing the bug is more difficult than I first thought. 
> I can't nail down what conditions cause scrolling not to work; the few times I
> have been able to reproduce it haven't been when I've had the debugger open.
> 
> Tracing through Apoint!EasyWheelEx, it looks like something similar to the
> Synaptics hack will also coax a scroll message out of the driver, though
> through a different code path.  It might be that this path doesn't trip over
> the same problem.  I am not overly hopeful, but please try this tryserver build
> to see if scrolling works (this doesn't include a window class name change to
> fix the forward/back problem):
> 
> http://ftp.mozilla.org/pub/mozilla.org/firefox/tryserver-builds/cmccormack@mozilla.com-eca9d286d6d6/tryserver-win32/firefox-4.0b12pre.en-US.win32.zip
> 
> Other points which may be of interest:
> 
> * The 3 passed as the last argument to EasyWheelEx is the number of lines to
>   scroll with each wheel notch, as returned by SystemParametersInfo
> * There doesn't seem to be a way to influence the scroll method passed to
>   EasyWheelEx other than by changing the ScrMethod registry entry, which is
>   global and read just when Apoint.exe starts up

I'm sorry to report that the tryserver build didn't change anything...
Comment 46 Cameron McCormack (:heycam) 2011-02-16 14:23:49 PST
Another stab in the dark: try this old build:

http://ftp.mozilla.org/pub/mozilla.org/firefox/nightly/2010/11/2010-11-01-04-mozilla-central/firefox-4.0b8pre.en-US.win32.zip

and set the ui.trackpoint_hack.enabled pref to 1.  (You'll need to restart after changing this.)

(The driver also checks for a ScrollBar child, which is what the Synaptics hack used to do before bug 594977, so it's worth a shot.)
Comment 47 Frank 2011-02-16 22:36:13 PST
Too bad. Didn't work either.
Comment 48 TBone 2011-02-26 22:43:26 PST
Laptop: Lenovo Thinkpad R61i
Device: Alps Touchpad (disabled) and Trackpoint
Driver Version: 7.202.1616.204 (no newer available from Lenovo, same result with older driver before)
OS: Windows XP Professional (32-bit) SP3
Firefox: 4.0b12
User-Agent: Mozilla/5.0 (Windows NT 5.1; rv:2.0b12) Gecko/20100101 Firefox/4.0b12

Symptoms: Window content cannot be scrolled vertically (also not horizontally, but I never use that) by moving the trackpoint while pressing the middle mouse button. Works in all other applications (except OpenOffice :( ).

I tried ui.trackpoint_hack.enabled with values 0 and 1, ui.window_class_override with value MozillaUIWindowClass but problem remained.

I have Winspector installed and would like to help so please let me know if there is anything I can do.
Comment 49 Stefan Katschewitz 2011-03-11 14:39:44 PST
Well, just upgraded from 3.6 to 4 RC and i'm not able to Scroll with my
Trackpoint or Touchpad (SL300, Alps 7.2.1623.307) in any direction.

Windows 7 32Bit
Comment 50 Kyle Huey [:khuey] (khuey@mozilla.com) 2011-03-11 14:43:02 PST
Yes, we know this is still broken.

This isn't in the RC1 relnotes ...?
Comment 51 Stefan Katschewitz 2011-03-11 14:46:14 PST
http://www.mozilla.com/en-US/firefox/4.0rc1/releasenotes/

You meen this? I couldn't find a hint.
Comment 52 Kyle Huey [:khuey] (khuey@mozilla.com) 2011-03-11 14:47:14 PST
Yes, this is supposed to be in the release notes (hence the relnote keyword) which is why I CCd Mike and Christian to make sure it gets in there for final.
Comment 53 Frank 2011-03-11 23:00:35 PST
(In reply to comment #52)
> ...to make sure it gets in there for final.

well that doesn't actually solve the problem. It's a real pitty. I was looking forward to FF4 for a long time, but now that it is close to being released I can't use it...

As far as I am concerned, I'm switching back to Chrome again until this bug is fixed. Sry guys, but I'm forced to...
Comment 54 Frank 2011-03-11 23:01:31 PST
btw: user TBone offered to help. Is there nothing he can do?
Comment 55 Cameron McCormack (:heycam) 2011-03-16 16:27:02 PDT
The best chance to solve the problem -- apart from hassling your laptop vendor to provide touchpad drivers with updated heuristics so that they don't fail to deliver scrolling messages to Firefox 4! -- is to have someone who is comfortable debugging the driver, stepping through the assembly, on a machine where this problem can be reproduced.

The second best chance is if the driver *is* sending scrolling messages to the Firefox window but for some reason they aren't being acted upon.  My impression is that this isn't the case (from Gábor's testing), but others can try.  TBone, can you use Winspector to log all of the messages sent to the Firefox window when you try to scroll with the touchpad?  Then attach the log to the bug here, or stick it in a pastebin.

Aside from that, without a developer having access to hardware on which the problem can be reproduced, there is little that can be done.
Comment 56 Frank 2011-03-17 00:37:42 PDT
(In reply to comment #55)
> ... there is little that can be done.

I totally understand the problem and your arguments. However I clearly have to say, that the same touchpad has worked great until now in every programm I have ever used and it still works great in every other browser (the latest dev of Chrome, the latest snapshots of Opera etc. which are far more volatile than Fx).

Furthermore, the issue obviously occurs on different major versions of the driver. 

Keeping in mind that it works well with any other type of program and that different major versions are affected, I'm not sure if the driver is to blame...

Nevertheless it would be really nice if TBone could help you guys out on investigating that issue!
Comment 57 Timothy Nikkel (:tnikkel) 2011-03-17 00:39:13 PDT
The reason is that the driver has code that is specific to Firefox. The driver does something different for Firefox then it does for every other application. If it just treated Firefox as it treats every other application things would just work.
Comment 58 Majken Connor [:Kensie] 2011-03-17 06:21:02 PDT
(In reply to comment #57)
> The reason is that the driver has code that is specific to Firefox. The driver
> does something different for Firefox then it does for every other application.
> If it just treated Firefox as it treats every other application things would
> just work.

Is there a way to "prove" this, ie is there some way users can trick the driver into treating Firefox like Chrome/IE so that they can see that's really the problem?
Comment 59 Geo_777 2011-03-17 06:52:48 PDT
Hi, I don't know if it helps but I noticed that scrolling on a Youtube window seems to work, as long as the cursor is on the flash window. It does make the page scroll down or up but if the cursors passes the surface of the flash window it stops scrolling.
I have an ALPS touchpad on my laptop.
Comment 60 Cameron McCormack (:heycam) 2011-03-17 14:11:05 PDT
The original change that broke these touchpad drivers was removal of any child widgets, except for plugins -- that's why scrolling works over plugins for Geo_777.

Interestingly, Opera 11 similarly has a single HWND for the whole window.  I'd be interested to see if scrolling in Opera is also broken for people who can't scroll in Firefox.  The window styles of the Opera and Firefox windows are the same, and the extended window styles are the same except that Opera also has WS_EX_ACCEPT_FILES.

If Opera 11 scrolling *does* work for you, and Firefox scrolling doesn't, can you try changing the ui.window_class_override pref to "OperaWindowClass" (and restarting)?

(Gábor did test changing it back to "MozillaUIWindowClass", but I'm not sure if he tried any other value.)
Comment 61 Stefan Katschewitz 2011-03-17 14:21:11 PDT
Just installed Opera 11.01 scrolling works fine with Trackpoint and Touchpad!
Comment 62 Stefan Katschewitz 2011-03-17 14:23:39 PDT
Changed the ui.window_class_override strin value to "OperaWindowClass" and restartet FF 4 RC. No changes in scrolling behavior, sry.
Comment 63 Geo_777 2011-03-17 14:42:12 PDT
> Interestingly, Opera 11 similarly has a single HWND for the whole window.  I'd
> be interested to see if scrolling in Opera is also broken for people who can't
> scroll in Firefox.  The window styles of the Opera and Firefox windows are the
> same, and the extended window styles are the same except that Opera also has
> WS_EX_ACCEPT_FILES.
> 
> If Opera 11 scrolling *does* work for you, and Firefox scrolling doesn't, can
> you try changing the ui.window_class_override pref to "OperaWindowClass" (and
> restarting)?

Accidentally I just installed Opera 11.10 beta just before reading your post and the scrolling doesn't work there either. I was actually surprised to see that but now I know why. :)
Comment 64 Stefan Katschewitz 2011-03-17 15:06:25 PDT
Scrolling works for me even in Opera 10.10 beta 1.
Comment 65 Stefan Katschewitz 2011-03-17 15:07:30 PDT
11.10 beta 1, I'm sry...
Comment 66 TBone 2011-03-17 19:10:00 PDT
WTF does FAKETRACKPOINTSCROLLCONTAINER mean?
http://imageupload.org/?d=4D82BEF01 (FF4RC).
Comment 67 Cameron McCormack (:heycam) 2011-03-17 19:28:17 PDT
Thanks for the screen shot.  The FAKETRACKPOINTSCROLLCONTAINER and FAKETRACKPOINTSCROLLABLE are hidden, zero size widgets used to trick the Synaptics driver into sending us scrolling messages (bug 594977 and an earlier one).

I take it you have an ALPS touchpad and not a Synaptics one; did you set the ui.trackpoint_hack.enabled pref to 1 to force that hack on?  So far it seems that hack doesn't work for ALPS drivers.

It would be useful though to log the messages when you try to scroll in both configurations (with that pref to 1, and set back to -1 (the default, which should mean disabled for your machine)).  So that means there should be four logs to get:

* with the pref set to -1, logging the messages sent to the main window

* with the pref set to 1:
    - logging the messages sent to the main window
    - logging those sent to the FAKETRACKPOINTSCROLLCONTAINER
    - logging those sent to the FAKETRACKPOINTSCROLLABLE
Comment 68 TBone 2011-03-17 19:54:32 PDT
I have an ALPS touchpad (which I do not use at all) and an ALPS trackpoint. I had the ui.trackpoint_enabled on -1 (and 1). If I set it to 0 and restart Firefox, the FAKETRACKPOINT windows do not show up in Winspector anymore but scrolling (middle trackpoint key plus trackpoint up/down) still does not work.

I am sorry, but I seem to be too dumb to get message logging to work and cannot find any documentation on Winspector. I tried logging messages from an Editor window but none show up. I do not use any message filters.

I use Windows XP SP3 with an unpriviledged user and start Winspector as administrator via right-click run as... Now trying when logged in as admin.
Comment 69 Cameron McCormack (:heycam) 2011-03-17 20:00:52 PDT
It's odd that the Synaptics hack would get turned on automatically.
...
Actually, after checking the code, it's not odd. :)

In widget/src/windows/nsWindow.cpp:

  } else if (HasRegistryKey(HKEY_CURRENT_USER, L"Software\\Alps\\Apoint\\TrackPoint")) {
    sDefaultTrackPointHack = PR_TRUE;

so at some point the Synaptics hack must've been useful for ALPS TrackPoints (which I think might just be in select Lenovo machines).

Anyway, whether you are leaving it autodetect to enabled, or explicitly disable it, it's not helping you.

I'm sorry I've never used Winspector before, so can't help you there.
Comment 70 TBone 2011-03-17 20:21:05 PDT
Strange, logging works when logged in as admin (FF crashes frequently though when Winspector is running).

The FAKE*-windows do not receive any messages with ui.trackpoint_hack.enabled set to -1, the mein window does receive messages, but no scrolling, mousewheel or similar when operating the trackpoint.

BTW: I do have the registry entry the code checks against.

In other windows the trackpoint generates WM_VSCROLL messages but they do not occur in the Firefox window.
Comment 71 TBone 2011-03-17 20:24:06 PDT
Same with ui.trackpoint_hack.enabled on 0.
Comment 72 Cameron McCormack (:heycam) 2011-03-17 20:29:28 PDT
OK, thanks very much for trying that.  There's nothing we can do then on the side of making Firefox respond to the driver's existing messages if none are being sent.
Comment 73 TBone 2011-03-17 20:47:15 PDT
I can report a minor success: When setting the scroll function to "smooth scrolling" in the control panel's "Ultra-Nav" (IBM's lingo for touchpad and trackpoint) tab scrolling DOES WORK.

This function works differently from the usual trackpoint scrolling function: Normally the content does only scroll while the middle trackpoint button is pressed and the trackpoint is pushed up or down. With smooth scrolling enabled a circular symbol appears on the screen when you press the middle button and the trackpoint controls the mouse corsor. The window content is scrolled in the direction of the line between the symbol to the cursor, the further the distance the faster the scrolling. i.e. in this mode scrolling does not stop when you stop pushing the trackpoint.

For me this is no good workaround, because I this mode is not as practical (i.e. it is easy to inadvertently scroll horizontally) and it can only be set globally.

Still, it is interesting to see Firefox' scrolling working in this mode.


the window contents move in the direction of the mous
Comment 74 TBone 2011-03-17 20:50:58 PDT
Please excuse above weird sentences (incomplete editing). I hope you can make sense of it anyhow.
Comment 75 TBone 2011-03-17 21:58:06 PDT
Thank you, Cameron, for your work and comments. I am more optimistic about what the dev team can do to fix this bug. The ALPS driver did not change, Firefox did and the trackpoint stopped working. The good news: Firefox can probably roll back that part that broke ALPS scrolling. We just need some way to pinpoint the cause of this.

Did anybody succeed in scrolling with an ALPS pointing device in an earlier version of Firefox 4?
Comment 76 Cameron McCormack (:heycam) 2011-03-17 22:01:25 PDT
Unfortunately, I don't think that change can be rolled back -- it was necessary for some graphics performance or correctness work, IIRC.
Comment 77 Frank 2011-03-18 00:06:45 PDT
(In reply to comment #76)
> Unfortunately, I don't think that change can be rolled back

dude? that's bad news.

however I have to interpose some information about scrolling behaviour in Opera 11.10 b1: what has been stated above is not completely true!

When I type a URL and open the site hitting enter, the site appears. When I'm moving the cursor somewhere over the actual website and try to scroll, nothing happens (so far so good - or bad); nevertheless as soon as I click ANYWHERE on this website (text, pics, empty space etc.) and try to scroll afterwards, it works from NOW ON on the entire page.

Obviously Opera uses the same methods as Fx4 but differs in a way.
Comment 78 Michael A. Puls II 2011-03-18 02:15:45 PDT
See Bug 582773 too (alps and autoscroll broken (in chrome and opera too)).
Comment 79 Stefan Katschewitz 2011-03-21 05:15:44 PDT
Is there any chance this bug will be fixed in tomorrows FF4 final?
More important: Is there anything we the troubled users can do to help fixing this?
Comment 80 Joe Drew (not getting mail) 2011-03-21 09:55:14 PDT
Firefox 4 RC2 is the same as Firefox 4 final, so you can actually test whether it will work tomorrow today!
Comment 81 Stefan Katschewitz 2011-03-21 10:31:27 PDT
Well, then we got a problem here... we already knew that it wasn't working with RC2...
This leaves me to my second point: How can we help to get rid of this problem?
Comment 82 Robert O'Callahan (:roc) (Exited; email my personal email if necessary) 2011-03-21 13:14:51 PDT
search all the files in the ALPS driver directory, and all the ALPS registry entries, for the string "firefox", and overwrite it with "xxxxxxx"? That might fix it. If it does, it might be useful to know which instance of "firefox" is the one that fixes it.

Renaming firefox.exe to something else might also help, but might break updates I guess...

There isn't a whole lot anyone can do here. The ALPS driver is badly designed, like many others, and singles out Firefox for special treatment that breaks Firefox 4. At some point I assume they'll fix their driver but that probably won't help existing users :-(.
Comment 83 Stefan Katschewitz 2011-03-21 14:16:21 PDT
I JUST DID IT!!! Here the deal! :)

I just remembered a fix for a scrolling issue with NetBeans that didn't work outand tried that one on FF 4 (find the Link at the end of this comment). I editied the "tp4table.dat" in "C:\Program Files\Apoint2K" (open your editor as adminstrator and open the file from there otherwise saving is impossible on Win7!). 

There are "Pass 1 rules". Simply add the following lines and scrolling will work in Firefox after just one reboot. I set the file to read-only but I have no idea if that was neccesary.

; Firefox
*,*,firefox.exe,*,*,*,WheelStd,1,9

Link: http://www.syaoran.net/blog/2010/01/how-to-enable-thinkpad-trackpoint-scrolling/
Comment 84 Stefan Katschewitz 2011-03-21 14:27:48 PDT
Would it be possible to add such a fix to the FF-Installation or is their no chance to write on foreign files?
Comment 85 Cameron McCormack (:heycam) 2011-03-21 14:44:49 PDT
Stefan, I'm happy that that fix works for you!  I suspect that it's not right for Firefox's installer to be messing with this file.

The file tp4table.dat comes from the Synaptics half of the driver.  (Exactly how the ALPS/Synaptics hybrid touchpad hardware works and how the drivers interact in these Lenovo machines is not clear to me.)  So it unfortunately won't be helpful for those people with purely ALPS touchpads.
Comment 86 Gábor Stefanik 2011-03-21 14:48:52 PDT
Umm... isn't tb4table.dat a Synaptics-specific file? At least, I can't find such a file in my APoint2K (ALPS) folder.
Comment 87 Cameron McCormack (:heycam) 2011-03-21 14:53:31 PDT
(In reply to comment #52)
> Yes, this is supposed to be in the release notes (hence the relnote keyword)
> which is why I CCd Mike and Christian to make sure it gets in there for final.

I can't see anything in http://www-trunk.stage.mozilla.com/en-US/firefox/4.0/releasenotes/index.html yet.  Will it be a note be added for the release?  I think it would be useful to mention this bug as well as bug 622410, for people whose Synaptics touchpads still don't work after bug 594977 was fixed.
Comment 88 Stefan Katschewitz 2011-03-21 15:07:57 PDT
That's bad, I hoped I fixed this one für everybody. Isn't there any simular file like the tp4table.dat for Touchpads?

I thought that the tp4table.dat is a file for touchpad and trackpoint which replaced a file only for the touchpad (maybe named somewhat like tbtable.dat i guessed)...
Comment 89 Stefan Katschewitz 2011-03-21 15:08:57 PDT
I forgot to mention, scrolling works for trackpoint AND touchpad for me now.
Comment 90 John Morgan 2011-03-23 17:07:19 PDT
Hello,
I, too, am experiencing this bug.  I'm using Windows 7 on an Acer Aspire 5315 laptop, with an ALPS touchpad (this 'mouse' has a center scroll button, and neither it nor the touchpad scrolling are working).  Uninstalled the drivers, and updated to 7.0.1101.17 (Acer's site has 7.0.1101.14), and still have the problem.  I wish that I had the *.dat file mentioned by Stefan, would be an easy fix. Looking forward to an update or workaround, because so far FF4 is sweet, except for this.
Comment 91 Gábor Stefanik 2011-03-23 17:48:05 PDT
John: Get the version 7.5.2015.1105 (not specifically listed for the 5315, but can be found on Google - AFAIK it is officially for the Aspire 7740, but works fine here with an 5720, of which 5315 is a stripped-down version), and use the ScrMethod hack I documented earlier to get vertical scrolling. Override the main window class to MozillaUIWindowClass to get back/forward support.
Comment 92 John Morgan 2011-03-23 19:21:07 PDT
Gabor,
Thanks.  How do I change the window class from MozillaWindowClass to MozillaUIWindowClass?  I can't find that in about:config.
Comment 93 nobugs 2011-03-23 20:27:19 PDT
Just another datapoint - I am experiencing this bug on a Lenovo ThinkPad SL300.  OS is Windows XP SP3.  Perhaps the Platform entry for this bug should be updated to include Windows XP and Vista.  
I have installed the latest version of the touchpad driver and utility program available from the Lenovo support website.  Scrolling works fine with FF 3.6.16.  I have reverted to 3.6.16, but I would be willing to install 4.0 again if there is a fix or a workaround someone would like me to try.  
A user posted a question about this problem on the SL300 in the support forum.  At the moment there are "89 people [who] have this problem; 86 new this week"  I believe there are other similar questions from users with this problem - some with Synaptics touchpads and some with Alps. It would be somewhat helpful if information about this could be included in the release notes and in a support or help document, so that affected users would know that the problem is being worked on.
Comment 94 Cameron McCormack (:heycam) 2011-03-23 20:43:46 PDT
Thanks for the information.  As far as I have been able to tell, those Lenovo machines that have an ALPS component also have a Synaptics component to them.  If that's the case, you could try editing the Synaptics driver's data file per comment 83, which seems to have worked for a couple of people.

If it's purely Synaptics (and editing tp4table.dat doesn't help), then bug 622410 tracks that.

I agree it would have been good to have bug 622410 and this one mentioned in the release notes as known issues.
Comment 95 TBone 2011-03-23 22:38:42 PDT
I did find a tp4table.dat file under programs\Apoint2K but editing it did not change anything, neither did renaming firefox.exe. I tried it with all combinations of the ui.trackpoint_hack.enabled and ui.window_class_override settings.
:-(

I wonder if ALPS could fix the driver without breaking things for FF3 users.
Comment 96 Stefan Katschewitz 2011-03-24 00:42:07 PDT
@nobugs@persocon.net: My fix in comment 83 needs to work, we got the exact same Notebook (SL300).

@ TBone: Did you add the fix to the pass 0 or pass 1 rules? I've just tried additing to the pass 1 rules which works fine for me.
Comment 97 TBone 2011-03-24 09:16:18 PDT
@S.K.: Tried it, no change. I do not think it matters where in the file you put the directive. The pass is defined by the last but one number, not by comments in the file.
Comment 98 Stefan Katschewitz 2011-03-24 09:24:09 PDT
Still I would give it a try if I were you. There seems to be some kind of difference if you look at the description:

; Pass 0 rules (These rules run first)

; Pass 1 rules (These rules run last)
;
; If no scrolling method was found with the builtin logic, then
; these rules are checked.

Sounds like Pass 1 rules are something like backup rules or what so ever. Don't waste this opportunity just because of your own laziness. :P
Comment 99 TBone 2011-03-24 11:28:31 PDT
I totally agree. But which pass a directive belongs to is defined by the directive itself, not by its position in the file. As I wrote above I tried it - to no avail.
Comment 100 Uli Stärk 2011-03-26 08:40:27 PDT
Created attachment 522113 [details]
Test of different tp4table config options

Thank you Stefan Katschewitz for pointing out, that it is possible to configure the driver and solve the problem. 

I did some tests and found out that you can use different scrolling types, pass and flag values. However scrolling type TwoParents or pass/flag 0,8 does not work at all. The option ui.trackpoint_hack.enabled does not seem to have any effect in FF4.

Maybe other users can try different combinations if it does not work.

Hint: You can rename your firefox.exe to test without an reboot.
Comment 101 Mark Banner (:standard8) 2011-03-26 11:51:32 PDT
(In reply to comment #0)
> ALPS driver version is 7.5.2015.1105 (APoint.exe is 7.3.0.29).

I have that driver and Firefox is broken on the default installation with an Acer Aspire 5542. Setting ScrMethod to 1 makes scrolling work again.

That's not really new info, but the interesting additional point is that OpenOffice (version 3.1.1) was also not scrolling when ScrMethod was set to 0 - it is now scrolling again.

Maybe there's a common issue with the driver or maybe between how the two apps operate?
Comment 102 Jochen Dausacker 2011-06-16 12:44:54 PDT
Hi,

i have the Problems on different Notebooks.

I Tried a Lenovo X60 Tablet, a IBM ThinkCentre with the External IBM ThinkPad Traveller USB-Keyboard (that has an UltraNav - Touchpad and a TouchPoint, and both don´t work on ALL Machines) I tried a Lenovo T400 an Apple MacBook Pro with the Build-In Multitouch-Touchpad and with the External Wireless MagicMouse.

So i think ther must be an General Solutin within the Firefox, and not with the Hardware-Drivers of ANY Scrolling - Devices.

The Scrolling-Problem turns only up with Firefox 4.01 , all "older" Versions don´t have this Issues...
Comment 103 Cameron McCormack (:heycam) 2011-06-16 14:51:52 PDT
Jochen, it seems unlikely to me that problems with scrolling on a MacBook with the built-in touchpad would be because of the same problem as the ALPS driver problems.  (Some Lenovo machines do have ALPS parts to their pointing devices, so that could well be this bug.)
Comment 104 TBone 2011-06-16 15:36:11 PDT
So how many are we still who have broken trackpoint scrolling in FF4? /raises hand/
Comment 105 spannerism 2011-06-16 15:40:38 PDT
It wouldn't work for me back in March.  I've not bothered d/ling FF4 as I'm sure it still won't work so sticking with FF3.

Someone let me know if their acer 5738Z suddenly starts working with FF4!
Comment 106 Frank 2011-06-17 23:10:37 PDT
(In reply to comment #104)
> So how many are we still who have broken trackpoint scrolling in FF4?
> /raises hand/

I had problems on my Sony Vaio back then. However I'm currently not on that machine. I'll test and report in a couple of days!
Comment 107 Joerg Gerlach 2011-06-22 20:43:14 PDT
Still not working with FF5 on an Acer Extensa 5630Z with an all pure ALPS touchpad. =/

J-
Comment 108 TBone 2011-06-23 06:33:47 PDT
Still not wirking with FF5 on a Lenovo R61i with ALPS trackpoint. =/
Comment 109 Stefan Katschewitz 2011-06-24 01:35:43 PDT
Have you already tried my fix? See Comment 83:
https://bugzilla.mozilla.org/show_bug.cgi?id=605357#c83
Comment 110 Joerg Gerlach 2011-06-24 03:32:49 PDT
(In reply to comment #109)
> Have you already tried my fix? See Comment 83:
> https://bugzilla.mozilla.org/show_bug.cgi?id=605357#c83

Yep, did that already when the problem accured on FF4. I don´t have that file as my toucpad seems to be an all pure ALPS touchpad, no Synaptics components anywhere...

J-
Comment 111 Jochen Dausacker 2011-06-24 08:38:51 PDT
(In reply to Comment #83)
> Have you already tried my fix? See Comment 83:
> https://bugzilla.mozilla.org/show_bug.cgi?id=605357#c83

I also tried this Fix, and it made it.

All of my Lenovos and IBM ThinkPad´s are now able to scroll like before.

That Miracle that occurs: on my MacBook Pro is the Scroll-Function now available, and i got the FF 4.0.1 running. Now im running on FF 5.0 and its already working. But, i ran a few Software-Updates from Apple seconds before, so that could be it....

I´m Surprised, and now im already working with Firefox only.
Comment 112 Joerg Gerlach 2011-07-09 23:59:49 PDT
The bug is now introduced to Thunderbird 5.0 as well. Awesome...
Comment 113 Stefan Katschewitz 2011-07-10 03:54:24 PDT
That's too bad, I'm sry for you.

For all Trackpoint Users: The Fix from Comment 83 works aswell! Just added this and  I'm able to scroll again in Thunderbird 5.0:

; Thunderbird
*,*,thunderbird.exe,*,*,*,WheelStd,1,9
Comment 114 TBone 2011-07-11 06:08:14 PDT
Just a reminder: I applied #83 carefully (tried serveral times) and still have no trackpoint scrolling functionality.
Comment 115 Sami Lappalainen / ZAS DATA 2011-07-15 01:29:55 PDT
I have a Thinkpad T61 which is very similar to R61 mentioned here.
Scrolling works fine in all Firefox versions, worked fine in Thunderbird before update to 5.0 but now is gone. :I
Comment 116 wahli 2011-08-14 13:12:37 PDT
I have a VAIO TX1, 6 years old. It has an ALPS pointing device.
Everything worked great in all programs and all browsers until Firefox 4 happenedd. 
Under pains I reverted to 3.x (it was hard to find the download)
Now Thunderbird 5 is doing just the same ****.

I really don't believe that ALPS especially singled out mozilla to screw with your settings. Since my driver is the same now for years, it cannot be that. It is whatever you guys changed in your coding.

I have been a faithful follower for almost 10 years, but given that I only have this notebookk, am very mobile and thus without a mouse dangling from a cord, this is a major pain. 

:(
wahli
Comment 117 Gábor Stefanik 2011-08-14 16:13:29 PDT
(In reply to wahli from comment #116)
> I have a VAIO TX1, 6 years old. It has an ALPS pointing device.
> Everything worked great in all programs and all browsers until Firefox 4
> happenedd. 
> Under pains I reverted to 3.x (it was hard to find the download)
> Now Thunderbird 5 is doing just the same ****.
> 
> I really don't believe that ALPS especially singled out mozilla to screw
> with your settings. Since my driver is the same now for years, it cannot be
> that. It is whatever you guys changed in your coding.
> 
> I have been a faithful follower for almost 10 years, but given that I only
> have this notebookk, am very mobile and thus without a mouse dangling from a
> cord, this is a major pain. 
> 
> :(
> wahli

Have you tried setting ScrMethod=1?
Comment 118 wahli 2011-08-15 02:18:37 PDT
(In reply to Gábor Stefanik from comment #117)

> 
> Have you tried setting ScrMethod=1?

I tried the registry-fix but that entry doesn't exist on my box.
and the tp4tables.dat file cannot be found on my box either. MAybe that's because the person who suggested this was running Vista?
And why the heck is it scrolling in IE, chrome, and FF 3.x if it's an ALPS issue?

driver is V 5.3.511.2  (yes it's old, but it always works (mozilla new products excluded)
I'm running XP SP3:

        
        
        DownloadHelper	4.9.4	true	{b9db16a4-6edc-47ec-a1f4-b86292ed211d}
Java Console	6.0.17	true	{CAFEEFAC-0016-0000-0017-ABCDEFFEDCBA}
Java Quick Starter	1.0	true	jqs@sun.com
Microsoft .NET Framework Assistant	0.0.0	true	{20a82645-c095-46ed-80e3-08825760534b}
NoScript	2.1.2.5	true	{73a6fe31-595d-460b-a920-fcc0f8843232}
Personas	1.6.2	true	personas@christopher.beard

        
       accessibility.blockautorefresh	true
accessibility.typeaheadfind.flashBar	0
browser.history_expire_days.mirror	180
browser.history_expire_days_min	21
browser.places.importBookmarksHTML	false
browser.places.importDefaults	false
browser.places.leftPaneFolderId	-1
browser.places.migratePostDataAnnotations	false
browser.places.smartBookmarksVersion	2
browser.places.updateRecentTagsUri	false
browser.startup.homepage	about:blank
browser.startup.homepage_override.buildID	20110318052756
browser.startup.homepage_override.mstone	rv:1.9.2.16
browser.tabs.warnOnClose	false
browser.zoom.full	false
extensions.lastAppVersion	3.6.16
font.name.serif.x-western	Tahoma
general.useragent.extra.microsoftdotnet	(.NET CLR 3.5.30729)
network.cookie.cookieBehavior	1
network.cookie.prefsMigrated	true
places.history.expiration.transient_current_max_pages	32004
places.last_vacuum	1312920402

cheers,
wahli
Comment 119 Michael A. Puls II 2011-08-15 02:25:38 PDT
Created attachment 553133 [details]
tp4table.dat from my synaptics driver

This is what tp4table.dat looks like for my synaptics driver (not alps). For Opera, I have have to comment out the opera.exe line to get horizontal scrolling with the middle button above the touchpad and the trackpoint to work. So, even if something works in other browsers, it doesn't necessarily mean it's a bug in your browser.

The driver has all kinds of different config options and settings in that file. Sometimes, whoever adds to that file gets things wrong or doesn't update it when things change.

Not sure that'll be much help with alps drivers. But, you could try putting it in the same directory as the drivers, kill the alops processes and restart them to see if it helps.
Comment 120 John Robinson 2011-08-15 04:12:57 PDT
(In reply to Stefan Katschewitz from comment #113)
> That's too bad, I'm sry for you.
> 
> For all Trackpoint Users: The Fix from Comment 83 works aswell! Just added
> this and  I'm able to scroll again in Thunderbird 5.0:
> 
> ; Thunderbird
> *,*,thunderbird.exe,*,*,*,WheelStd,1,9

I can confirm that when I add the above to my C:\Program Files\Apoint2K\tp4table.dat file at the bottom of the "pass 1 rules" section, then kill and restart Apoint.exe, I now have scrolling again with both the side of the trackpad and the trackpoint, on my Lenovo ThinkPad R61 with Windows 7 64-bit, Thunderbird 5.0, Alps ThinkPad UltraNav driver version 7.202.1616.206.
Comment 121 Gábor Stefanik 2011-08-15 08:31:48 PDT
(In reply to wahli from comment #118)
> (In reply to Gábor Stefanik from comment #117)
> 
> > 
> > Have you tried setting ScrMethod=1?
> 
> I tried the registry-fix but that entry doesn't exist on my box.
> and the tp4tables.dat file cannot be found on my box either. MAybe that's
> because the person who suggested this was running Vista?
> And why the heck is it scrolling in IE, chrome, and FF 3.x if it's an ALPS
> issue?
> 
> driver is V 5.3.511.2  (yes it's old, but it always works (mozilla new
> products excluded)
> I'm running XP SP3:
> 
>         

Tp4tables.dat only exists on ThinkPads with Synaptic TrackPoints, but ALPS touchpads. On pure ALPS systems, it does not exists.

The ScrMethod registry entry may not exist by default - you need to create it yourself (it's a DWORD). But I'm not sure if a 5.x driver will recognize ScrMethod.)
Comment 122 a_bllod 2011-09-08 16:28:59 PDT
Hi, I've an Acer Aspire 5720, with an Alps Touchpad (Alps driver ver. 7.0.1101.11, 22/06/2007) and Vista Home Premium. 
I just want to describe you my experience, hoping it could be useful for users and developers.

I experimented the touchpad scrolling no working with FF4, TB4, and their most recent versions, and even with Open Office 3.3 (no problems with OO 3.2). 
In my case, it seems to be an interference with Windows Sidebar: if I exit (not only close) the Windows Sidebar software, everything works!

Before I tried different solutions proposed in the posts of support.mozilla.com, but only the registry fix of the key <ScrMethod> worked... 
(In my notebook there is no Tp4tables.dat file)

But I ever looked for another solution: I didn't understand why a method of handling the scroll events of my touchpad is working with all softwares, but the last versions of those ones... 

While I was trying the touchpad scroll on FF6 (with SrcMethod=0), I noted that I was interacting with the Presentation Widget of Windows Sidebar, though FF6 was the active window... 
I closed the widget, but the scroll didn't work yet... 
I closed the Sidebar: nothing... 
Finally I did exit from the Windows Sidebar program and magically the scroll worked!

So, it seems that Windows Sidebar has a higher priority in handling the scroll events of my touchpad than FF, TB and OO: it intercepts the scroll events and doesn't pass them to the right applications! 

If you don't really need Windows Sidebar, exit (not only close) Windows Sidebar and try... after you will choose whether to continue to have Sidebar running on your notebook or to work with the most recent versions of FF, TB and OO and scroll...
Comment 123 woodson 2011-10-12 18:18:32 PDT
(In reply to Gábor Stefanik from comment #2)
> Note: Vertical scrolling can be made to work by setting
> HKLM\Software\Alps\Apoint\ScrMethod to 1 (some drivers set this to 1 by
> default, set it to 0 to reproduce this bug). However, ScrMethod=1 is much
> choppier/more CPU-intensive than ScrMethod=0 in almost all applications
> tried. Horizontal scrolling is unchanged.
> 
> Back/Forward not working is due to apoint.exe checking for
> MozillaUIWindowClass to enable back/forward - only it is now
> MozillaWindowClass. Hexediting apoint.exe to check for MozillaWindowClass
> instead of MozillaUIWindowClass fixes the issue. I wonder if we should
> create a fake MozillaUIWindowClass if apoint.exe is detected in memory, akin
> to ui.trackpoint_hack.enabled...

I could not find the HKLM reference but searched for ScrMethod and found three references all related to alps driver. I changed the 0 to 1 on all three spots and side bars now work for me.
Thanks
Woody
Comment 124 Colin Finck 2012-07-12 12:21:04 PDT
Has this regressed again?
I've just upgraded from Firefox 3.6.28 to 13.0.1 on my ThinkPad R61 (Windows XP, ALPS driver 7.202.1616.206) and no scrolling is possible with TrackPoint or Touchpad after trying out all the tricks here. In particular I have tried:

* Adding "*,*,firefox.exe,*,*,*,WheelStd,1,9" to tp4table.dat in Pass 0 and Pass 1 rules
* Trying the same line in "tp4scrol.dat"
* Hexediting Apoint.exe to change "MozillaUIWindowClass" to "MozillaWindowClass"
* ScrMethod set to 0 and 1 in the registry
* ui.trackpoint_hack.enabled set to -1, 0, and 1

Scrolling in the not-yet upgraded Thunderbird 3.1.20 still works perfectly.
Anybody else with the same experiences? Anything else I could try?

Thanks in advance,

Colin
Comment 125 Paul Pasca[Away. Please needinfo? Paul Oiegas [:pauloiegasSV]] 2016-04-21 06:10:32 PDT
Hi reporter,

I don't have a laptop with touch pad in order to try to reproduce this issue. Is this still reproducible on your end ? If yes, can you please retest this using latest FF release and latest Nightly build (https://nightly.mozilla.org/) and report back the results ? When doing this, please use a new clean Firefox profile, maybe even safe mode, to eliminate custom settings as a possible cause (https://goo.gl/PNe90E).

Thanks,
Paul.
Comment 126 Sami Lappalainen / ZAS DATA 2016-04-21 07:29:28 PDT
Hi,

Works now with my Thinkpad T410. Though this bug might have been submitted on a T61 or T400.
Someone could test with an older model.
Comment 127 Gábor Stefanik 2016-04-27 02:39:14 PDT
Does the T410 have an Alps trackpad? Also, did you test both the trackpad and the trackpoint?

BTW, this bug was filed on an Acer, not a ThinkPad.

Note You need to log in before you can comment on or make changes to this bug.